//
//  DesignViewController.swift
//  ecp_sync_plugin
//
//  Created by Amit satyapanthi on 16/03/19.
//

import UIKit
import PureLayout
import Foundation
import MTBBarcodeScanner
import AVFoundation

protocol BarcodeScannerViewControllerDelegate: NSObjectProtocol {
    func barcodeScannerViewController(_ controller: UIViewController?, didScanBarcodeWithResult result: String?)
    func barcodeScannerViewController(_ controller: UIViewController?, didFailWithErrorCode errorCode: String?)
}

class DesignViewController: UIViewController {
    
    let containerView: UIView = {
        let view = UIView.newAutoLayout()
        view.backgroundColor = .lightGray
        return view
    }()
    /*let blueView: UIView = {
        let view = UIView.newAutoLayout()
        view.backgroundColor = .white
        return view
    }()*/
    let redView: UIView = {
        let view = UIView.newAutoLayout()
        view.backgroundColor = .red
        return view
    }()
    
    var countView: UIButton = {
        let label = UIButton.newAutoLayout()
        label.backgroundColor = UIColor(white: 1, alpha: 0) // semi-transparent purple
        label.setTitle("0", for: .normal)
        //label.textColor = .white
        //label.text = "NEXT"
        return label
    }()
    
    
    //004a96
    var redView1: UIButton = {
        let label = UIButton.newAutoLayout()
        label.backgroundColor = UIColor(white: 1, alpha: 0.5) // semi-transparent purple
        
        label.setTitle("NEXT", for: .normal)
        
        //label.textColor = .white
        //label.text = "NEXT"
        return label
    }()
    
    let redView2: UIButton = {
        let label = UIButton.newAutoLayout()
        label.backgroundColor = UIColor(white: 1, alpha: 0) // semi-transparent purple
        label.setTitle("Scan your 2D label here...", for: .normal)
        
        //label.textColor = .white
        //label.text = "NEXT"
        return label
    }()
    
    /*let redView2: UILabel = {
     let label = UILabel.newAutoLayout()
     //label.backgroundColor = UIColor.tr // semi-transparent purple
     label.textColor = .white
     label.text = "Scan your 2D label here..."
     return label
     }()*/
    
    var didSetupConstraints = false
    var screenWidth:CGFloat = 0
    var screenHeight:CGFloat = 0
    var blueView:UIView!
    var scanner: MTBBarcodeScanner?
    var itesm = [String]()
    var itesmNew = [String]()
    // @IBOutlet var countButton: UIButton!
    var delegate:BarcodeScannerViewControllerDelegate!
    var isSingleScan:Bool = true
    var isPlaySound:Bool = true
    var isOnFlase:Bool = true
    var themeColor:String = "#004a96"

    override func viewDidLoad() {
        super.viewDidLoad()
        
        let screenSize = UIScreen.main.bounds
        screenWidth = screenSize.width
        screenHeight = screenSize.height
        
        view = UIView()
        view.backgroundColor = UIColor(white: 0.1, alpha: 1.0)
        
        blueView = UIView(frame: view.bounds)
        blueView.translatesAutoresizingMaskIntoConstraints = false
        //view.addSubview(previewView)
        /*view.addConstraints(NSLayoutConstraint.constraints(withVisualFormat: "V:[previewView]", options: .alignAllBottom, metrics: nil, views: [
            "previewView": previewView
            ]))
        view.addConstraints(NSLayoutConstraint.constraints(withVisualFormat: "H:[previewView]", options: .alignAllBottom, metrics: nil, views: [
            "previewView": previewView
            ]))*/
        //countView.backgroundColor = hexStringToUIColor(hex: "#80000000")
        redView1.backgroundColor = hexStringToUIColor(hex: themeColor)
        
        view.addSubview(blueView)
        //blueView.addSubview(redView)
        //blueView.addSubview(yellowView)
        //blueView.addSubview(previewView)
        
        redView1.addTarget(self, action:#selector(buttonPressed(_:)), for:.touchUpInside)
        
        blueView.addSubview(redView2)
        blueView.addSubview(redView1)
        blueView.addSubview(countView)
        
        scanner = MTBBarcodeScanner(previewView: blueView)
        
        navigationController?.navigationBar.barTintColor = hexStringToUIColor(hex: themeColor)
        navigationController?.navigationBar.tintColor = UIColor.white
        navigationItem.leftBarButtonItem = UIBarButtonItem(barButtonSystemItem: .cancel, target: self, action: #selector(self.cancel))
        let icon = UIImage(named: "backIcon")!
        navigationItem.leftBarButtonItem = UIBarButtonItem(image: icon, style: .plain, target: self, action: #selector(self.cancel))
        /*if(self.isSingleScan == false){
            navigationItem.rightBarButtonItem = UIBarButtonItem(barButtonSystemItem: .done, target: self, action: #selector(self.doneScanning))
        }*/
        updateFlashButton()
        
        view.setNeedsUpdateConstraints() // bootstrap Auto Layout
    }
    
    var isClicked:Bool = false
    
    @objc func buttonPressed(_ sender: AnyObject) {
        
        if(isClicked == false){
            
            isClicked = true
            
            let myGroup = DispatchGroup()
            
            myGroup.enter()
            //print("details...")
            if(self.scanner != nil){
                self.scanner?.stopScanning()
            }
            print("scan count:\(self.itesm.count)")
            let strr:String = jsonData(from: self.itesm)!
            print("scan json:\(strr)")
            
            self.delegate?.barcodeScannerViewController(self, didScanBarcodeWithResult: strr)
            print("buttonPressed")
            
            myGroup.leave()
            
            /*dispatch_group_notify(myGroup, dispatch_get_main_queue(), {
             self.dismiss(animated: false)
             })*/
            
            myGroup.notify(queue: DispatchQueue.main, execute: {
                self.isClicked = false
                self.dismiss(animated: false)
                
            })
        }
        
        
    }
    
    override func viewDidAppear(_ animated: Bool) {
        if ((scanner?.isScanning) != nil) {
            scanner?.stopScanning()
        }
        MTBBarcodeScanner.requestCameraPermission(success: { success in
            if success {
                self.startScan()
            } else {
                //self.delegate.barcodeScannerViewController(self, didFailWithErrorCode: "PERMISSION_NOT_GRANTED")
                print("PERMISSION_NOT_GRANTED")
                self.dismiss(animated: false)
            }
        })
    }
    
    override func viewWillDisappear(_ animated: Bool) {
        
        
        super.viewWillDisappear(animated)
        
        scanner?.stopScanning()
        super.viewWillDisappear(animated)
        if isFlashOn() {
            toggleFlash(false)
        }
    }
    
    func startScan() {
        var error: Error?
        try? scanner?.startScanning(resultBlock: { codes in
            
            if(codes != nil){
                
                let code: AVMetadataMachineReadableCodeObject? = codes?.first
                if code != nil {
                    
                    print("---------------")
                    print(codes)
                    print("---------------")
                    
                    var stringValue : String = (code?.stringValue)!
                    //codeScanned = stringValue
                    
                    if(stringValue != ""){
                        
                        //print("stringValue code: \(stringValue)")
                        var isGoing = false
                        
                        if(stringValue.characters.count <= 14){
                            isGoing = true
                        }
                        
                        if(isGoing == false){
                            let swiftyString = stringValue.replacingOccurrences(of: "\"", with: "")
                            //print("swiftyString:\(swiftyString)")
                            let trimmedString = swiftyString.trimmingCharacters(in: .whitespaces)
                            //print("trimmedString:\(trimmedString)")
                            
                            
                            
                            var ites:Int = 0
                            var finalStr:String = ""
                            var groupSaprator:String = ""
                            while(ites < trimmedString.characters.count){
                                let firstChar = Array(trimmedString)[ites]
                                
                                let charAscii = firstChar.ascii
                                if(charAscii != 29){
                                    finalStr = finalStr + "\(firstChar)"
                                }else{
                                    finalStr = finalStr + "\(firstChar)"
                                    groupSaprator = "\(firstChar)"
                                }
                                
                                ites = ites + 1
                            }
                            
                            if(!finalStr.isEmpty){
                                if(!groupSaprator.isEmpty){
                                    let group = finalStr.components(separatedBy: groupSaprator)
                                    //print(group)
                                    //print(group[0])
                                    //print(group[1])
                                    
                                    var str1:String = group[group.count - 1]
                                    //print(str1)
                                    if(!str1.isEmpty){
                                        
                                        
                                        if let index = str1.index(str1.startIndex, offsetBy: 0, limitedBy: str1.endIndex) {
                                            str1.remove(at: index)
                                            //print(str1) // prints "Hello I must be going"
                                        }
                                        
                                        if let index = str1.index(str1.startIndex, offsetBy: 0, limitedBy: str1.endIndex) {
                                            str1.remove(at: index)
                                            //print(str1) // prints "Hello I must be going"
                                        }
                                        
                                        stringValue = str1
                                        //print("stringValue : \(stringValue)")
                                    }
                                }
                            }
                        }
                        
                        if(!self.itesm.contains(stringValue)){
                            print("Found code: \(stringValue)")
                            self.itesm.append(stringValue)
                            
                            if(self.isPlaySound){
                                //self.countButton.setTitle("\(self.itesm.count)", for: .normal)
                                // create a sound ID, in this case its the tweet sound.
                                let systemSoundID: SystemSoundID = 1017
                                // to play sound
                                AudioServicesPlaySystemSound (systemSoundID)
                            }
                            
                            self.countView.setTitle("\(self.itesm.count)", for: .normal)
                            
                            if(self.isSingleScan){
                                self.scanner?.stopScanning()
                                
                                self.dismiss(animated: false)
                            }
                        }
                        
                    }
                }
            }
        })
    }
    
    func toggleFlash(_ on: Bool) {
        let device = AVCaptureDevice.default(for: .video)
        if device == nil {
            return
        }
        
        var err: Error?
        if device?.hasFlash ?? false && device?.hasTorch ?? false {
            try? device?.lockForConfiguration()
            if err != nil {
                return
            }
            if on {
                device?.flashMode = .on
                device?.torchMode = .on
            } else {
                device?.flashMode = .off
                device?.torchMode = .off
            }
            device?.unlockForConfiguration()
        }
    }
    
    @objc func toggle() {
        toggleFlash(!isFlashOn())
        updateFlashButton()
    }
    
    func isFlashOn() -> Bool {
        
        return false
        
    }
    
    @objc func cancel() {
        self.delegate.barcodeScannerViewController(self, didFailWithErrorCode: "err")
        dismiss(animated: true)
    }
    
    func jsonData(from object:Any) -> String? {
        guard let data = try? JSONSerialization.data(withJSONObject: object, options: []) else {
            return nil
        }
        return String(data: data, encoding: String.Encoding.utf8)
    }
    
    @objc func doneScanning() {
        if(self.isSingleScan == false){
            self.scanner?.stopScanning()
            print("scan count:\(self.itesm.count)")
            let strr = jsonData(from: self.itesm)
            //print("scan json:\(strr)")
           // self.delegate.barcodeScannerViewController(self, didScanBarcodeWithResult: strr)
            self.dismiss(animated: false)
            
            /*self.scanner?.stopScanning()
             self.delegate.barcodeScannerViewController(self, didScanBarcodeWithResult: stringValue)
             self.dismiss(animated: false)*/
        }
    }
    
    var hasTorch: Bool {
        let device = AVCaptureDevice.default(for: .video)
        if device != nil {
            return device?.hasTorch ?? false
        }
        return false
    }
    
    func updateFlashButton() {
        if !hasTorch {
            return
        }
        /*if isFlashOn() {
            navigationItem.rightBarButtonItem = UIBarButtonItem(title: "Flash Off", style: .plain, target: self, action: #selector(self.toggle))
        } else {
            navigationItem.rightBarButtonItem = UIBarButtonItem(title: "Flash On", style: .plain, target: self, action: #selector(self.toggle))
        }*/
    }
    
    // IBAction
    @IBAction func buttonTapped(_ sender: UIButton){
        print("button tapped")
    }
    

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destination.
        // Pass the selected object to the new view controller.
    }
    */
    
    func hexStringToUIColor (hex:String) -> UIColor {
        var cString:String = hex.trimmingCharacters(in: .whitespacesAndNewlines).uppercased()
        
        if (cString.hasPrefix("#")) {
            cString.remove(at: cString.startIndex)
        }
        
        if ((cString.characters.count) != 6) {
            return UIColor.gray
        }
        
        var rgbValue:UInt32 = 0
        Scanner(string: cString).scanHexInt32(&rgbValue)
        
        return UIColor(
            red: CGFloat((rgbValue & 0xFF0000) >> 16) / 255.0,
            green: CGFloat((rgbValue & 0x00FF00) >> 8) / 255.0,
            blue: CGFloat(rgbValue & 0x0000FF) / 255.0,
            alpha: CGFloat(1.0)
        )
    }
    
    override func updateViewConstraints() {
        if (!didSetupConstraints) {
            // Before layout margins were introduced, this is a typical way of giving a subview some padding from its superview's edges
            blueView.autoPin(toTopLayoutGuideOf: self, withInset: 10.0)
            blueView.autoPinEdgesToSuperviewEdges(with: UIEdgeInsets(top: 0, left: 0, bottom: 50.0, right: 0), excludingEdge: .top)
            
            // Set the layoutMargins of the blueView, which will have an effect on subviews of the blueView that attach to
            // the blueView's margin attributes -- in this case, the redView
            blueView.layoutMargins = UIEdgeInsets(top: 10.0, left: 20.0, bottom: 80.0, right: 20.0)
            //redView.autoPinEdgesToSuperviewMargins()
            
            // Let the redView inherit the values we just set for the blueView's layoutMargins by setting the below property to YES.
            // Then, pin the yellowView's edges to the redView's margins, giving the yellowView the same insets from its superview as the redView.
            //redView.preservesSuperviewLayoutMargins = true
            //yellowView.autoPinEdge(toSuperviewMargin: .left)
            //yellowView.autoPinEdge(toSuperviewMargin: .right)
            
            // By aligning the yellowView to its superview's horizontal margin axis, the yellowView will be positioned with its horizontal axis
            // in the middle of the redView's top and bottom margins (causing it to be slightly closer to the top of the redView, since the
            // redView has a much larger bottom margin than top margin).
            //yellowView.autoAlignAxis(toSuperviewMarginAxis: .horizontal)
            //yellowView.autoMatch(.height, to: .height, of: blueView, withMultiplier: 0.5)
            
            // Since yellowView.preservesSuperviewLayoutMargins is NO by default, it will not preserve (inherit) its superview's margins,
            // and instead will just have the default margins of: {8.0, 8.0, 8.0, 8.0} which will apply to its subviews (greenView)
            countView.autoPinEdges(toSuperviewMarginsExcludingEdge: .bottom)
            //greenView.autoSetDimension(.height, toSize: 50.0)
            countView.autoSetDimensions(to: CGSize(width: 100.0, height: 50.0))
            
            // 2D label
            // Use a cross-attribute constraint to constrain an ALAxis (Horizontal) to an ALEdge (Bottom)
            redView2.autoConstrainAttribute(.horizontal, to: .marginBottom, of: blueView)
            
            redView2.autoAlignAxis(.vertical, toSameAxisOf: blueView)
            redView2.autoSetDimensions(to: CGSize(width: screenWidth, height: 50.0))
            //-------
            
            // Use a cross-attribute constraint to constrain an ALAxis (Horizontal) to an ALEdge (Bottom)
            redView1.autoConstrainAttribute(.horizontal, to: .bottom, of: blueView)
            redView1.autoAlignAxis(.vertical, toSameAxisOf: blueView)
            redView1.autoSetDimensions(to: CGSize(width: screenWidth, height: 50.0))
            
            didSetupConstraints = true
        }
        
        super.updateViewConstraints()
    }

}
