import Flutter
import UIKit
import SSZipArchive
import Alamofire
import SwiftyJSON
import Foundation
import SystemConfiguration
import Foundation
import CryptoSwift
import FMDB

public class SwiftEcpSyncPlugin: NSObject, FlutterPlugin, FlutterStreamHandler, BarcodeScannerViewControllerDelegate {
    
    let database: FMDatabase
    
    let documentsPath = NSURL(fileURLWithPath: NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true)[0])
 
    func barcodeScannerViewController(_ controller: UIViewController?, didScanBarcodeWithResult result: String?) {
        print("didScanBarcodeWithResult")
        //resultResend(result)
        
        //let items:String = result!
        
        returnItems = ["type": "11","Details": result,"progress": "0"] as! [String : String]
        NotificationCenter.default.post(name: notificationName, object: nil)
    }
    
    func barcodeScannerViewController(_ controller: UIViewController?, didFailWithErrorCode errorCode: String?) {
        print("didFailWithErrorCode")
        //
        if(errorCode == "PERMISSION_NOT_GRANTED"){
            returnItems = ["type": "12","Details": "Permission not granted, Please try again","progress": "0"]
        }else{
            returnItems = ["type": "12","Details": errorCode,"progress": "0"] as! [String : String]
        }
        
        NotificationCenter.default.post(name: notificationName, object: nil)
        //resultResend(errorCode)
    }
    
    
    private var eventSink: FlutterEventSink?
    let notificationName = Notification.Name("plugin_Progress")
    private var argumentsde: [AnyHashable : Any] = [:]
    var dict : Dictionary = Dictionary<String,String>()
    var alamofireManager : Alamofire.SessionManager?
    var zipNameFinal:String = ""
    var returnItems = ["type": "dhaval","Details": "dhaval","progress": "45"]
    var hostVC:UIViewController!
    var hashMap = [String : String]()
    var resultResend:FlutterResult!
    
    public override init() {
        let configuration = URLSessionConfiguration.default
        configuration.timeoutIntervalForRequest = 500
        configuration.timeoutIntervalForResource = 500 // seconds
        alamofireManager = Alamofire.SessionManager(configuration: configuration)
        
        database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-HK-Database.db")?.path)
    }
    
    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: "ecp_sync_plugin", binaryMessenger: registrar.messenger())
        let instance = SwiftEcpSyncPlugin()
        registrar.addMethodCallDelegate(instance, channel: channel)
        
        let chargingChannel = FlutterEventChannel(name: "ecp_sync_plugin_Progress", binaryMessenger: registrar.messenger())
        //chargingChannel.streamHandler = instance
        chargingChannel.setStreamHandler(instance)
        
        instance.hostVC = UIApplication.shared.delegate?.window??.rootViewController
    }
    
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        
        if let arguments = call.arguments {
            // argumentsde = arguments as! [AnyHashable : Any]
            dict = arguments as! Dictionary<String,String>
        }
        
        /*'UserName': UserName,
         'fk_EmpGlCode': fk_EmpGlCode,
         'ClientName': ClientName,
         'imei': imei,
         'version': appVersion,
         'uploadMethod': uploadMethod,
         'urlUpload': urlUpload,
         'databaseName': databaseName,
         'packageName': packageName*/
        
        //result("iOS \(String(describing: args))" + UIDevice.current.systemVersion)
     if(call.method == "syncronizeData"){
          
          let UserName : String = dict["UserName"] ?? ""
          let fk_EmpGlCode : String = dict["fk_EmpGlCode"] ?? ""
          let ClientName : String = dict["ClientName"] ?? ""
          let imei : String = dict["imei"] ?? ""
          let version : String = dict["version"] ?? ""
          let uploadMethod : String = dict["uploadMethod"] ?? ""
          let urlUpload : String = dict["urlUpload"] ?? ""
          var databaseName : String = dict["databaseName"] ?? ""
          let packageName : String = dict["packageName"] ?? ""
          let dbPassword : String = dict["dbPassword"] ?? ""
          let isDbEncripted : String = dict["isDbEncripted"] ?? ""
          
          //databaseName = "BASF-HK-Database"
          
          print("UserName:\(String(describing: UserName))")
          print("fk_EmpGlCode:\(String(describing: fk_EmpGlCode))")
          print("ClientName:\(String(describing: ClientName))")
          print("imei:\(String(describing: imei))")
          print("version:\(String(describing: version))")
          print("uploadMethod:\(String(describing: uploadMethod))")
          print("urlUpload:\(String(describing: urlUpload))")
          print("databaseName:\(String(describing: databaseName))")
          print("packageName:\(String(describing: packageName))")
          print("dbPassword:\(String(describing: dbPassword))")
          print("isDbEncripted:\(String(describing: isDbEncripted))")
          //print("\(String(describing:UserName))")
          NotificationCenter.default.post(name: notificationName, object: nil)
          //result("iOS fk_EmpGlCode:\(String(describing: fk_EmpGlCode)) :: UserName:\(String(describing: UserName)) imei:\(String(describing: imei)) version:\(String(describing: version)) uploadMethod:\(String(describing: uploadMethod)) databaseName:\(String(describing: databaseName)) packageName:\(String(describing: packageName))" + UIDevice.current.systemVersion)
          let retval = SyncData(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei,uploadMethod:uploadMethod,urlUpload:urlUpload,databaseName:databaseName, dbPassword: dbPassword, isDbEncripted: isDbEncripted)
          
          result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)
     }else if(call.method == "encodeData"){
            let details : String = dict["details"] ?? ""
            let key : String = dict["key"] ?? ""
            let iv : String = dict["iv"] ?? ""
            
            //let key = "B4V2A1C@S#S$F"
            //let iv = "0000000000000000"
            //let s = "Vcs@1234"
            let enc = try! details.aesEncrypt1(key: key, iv: iv)
            print(enc)
            result(enc)
            
            
        }else if(call.method == "decodeData"){
            let details : String = dict["details"] ?? ""
            let key : String = dict["key"] ?? ""
            let iv : String = dict["iv"] ?? ""
            
            do{
                let dec = try details.aesDecrypt1(key: key, iv: iv)
                print("dec:\(dec)")
                print("\(details == dec)")
                result(dec)
            }catch let error {
                print("error:\(error)")
                result("error:\(error)")
            }
            
        }else if(call.method == "scanBarCodes"){
            /*let scannerViewController = BarcodeScannerViewController()
             let navigationController = UINavigationController(rootViewController: scannerViewController)
             scannerViewController.delegate = self
             hostViewController.present(navigationController, animated: false)*/
            
            /*let storyBoard = UIStoryboard(name: "Main_devs", bundle: nil)
             let mainViewController = storyBoard.instantiateViewController(withIdentifier: "ViewController")
             hostVC.present(mainViewController, animated: false)*/
            
             /*let isSingleScan : String = dict["isSingleScan"] ?? ""
             let isPlaySound : String = dict["isPlaySound"] ?? ""
             let isOnFlase : String = dict["isOnFlase"] ?? ""
             
             
             resultResend = result
             let scannerViewController = ViewController()
             let navigationController = UINavigationController(rootViewController: scannerViewController)
             scannerViewController.delegate = self
             scannerViewController.isSingleScan = isSingleScan.bool ?? false
             scannerViewController.isPlaySound = isPlaySound.bool ?? false
             scannerViewController.isOnFlase = isOnFlase.bool ?? false
             hostVC.present(navigationController, animated: false)*/
            
            let isSingleScan : String = dict["isSingleScan"] ?? ""
            let isPlaySound : String = dict["isPlaySound"] ?? ""
            let isOnFlase : String = dict["isOnFlase"] ?? ""
            let themeColor : String = dict["themeColor"] ?? ""
          
          let storyBoard = UIStoryboard(name: "Main", bundle: nil)
          
          let mainViewController = storyBoard.instantiateViewController(withIdentifier: "ViewController") as! ViewController
          //NaviViewController
          
         // mainViewController.navigationBarHidden 
          
          mainViewController.delegate = self
          mainViewController.isSingleScan = isSingleScan == "true"
          mainViewController.isPlaySound = isPlaySound == "true"
          mainViewController.isOnFlase = isOnFlase == "true"
          if(themeColor != ""){
               mainViewController.themeColor = themeColor
          }
          let navigationController = UINavigationController(rootViewController: mainViewController)
          
          hostVC.present(navigationController, animated: true, completion: nil)
          
          //hostVC.present(mainViewController, animated: false)
          //hostVC.navigationController?.present(mainViewController, animated: true, completion: nil)
          
          //let scannerViewController = ViewController()
          //let navigationController = UINavigationController(rootViewController: scannerViewController)
          //scannerViewController.delegate = self
          //scannerViewController.isSingleScan = isSingleScan.bool ?? false
          //scannerViewController.isPlaySound = isPlaySound.bool ?? false
          //scannerViewController.isOnFlase = isOnFlase.bool ?? false
          //hostVC.present(navigationController, animated: false)
            
            /*let scannerViewController = DesignViewController()
            scannerViewController.delegate = self
            scannerViewController.isSingleScan = isSingleScan.bool ?? false
            scannerViewController.isPlaySound = isPlaySound.bool ?? false
            scannerViewController.isOnFlase = isOnFlase.bool ?? false
            if(themeColor != ""){
                scannerViewController.themeColor = themeColor
            }
            let navigationController = UINavigationController(rootViewController: scannerViewController)
            hostVC.present(navigationController, animated: false)*/
            
            //result("scanBarCodes")
            //getDeviceUniqueNo
            
            // Sagar File Sync ################################################
            
            /*let UserName : String = dict["UserName"] ?? ""
            let fk_EmpGlCode : String = dict["fk_EmpGlCode"] ?? ""
            let ClientName : String = dict["ClientName"] ?? ""
            let imei : String = dict["imei"] ?? ""
            let version : String = dict["version"] ?? ""
            let uploadMethod : String = dict["uploadMethod"] ?? ""
            let urlUpload : String = dict["urlUpload"] ?? ""
            var databaseName : String = dict["databaseName"] ?? ""
            let packageName : String = dict["packageName"] ?? ""
            
            //databaseName = "BASF-HK-Database"
            
            print("UserName:\(String(describing: UserName))")
            print("fk_EmpGlCode:\(String(describing: fk_EmpGlCode))")
            print("ClientName:\(String(describing: ClientName))")
            print("imei:\(String(describing: imei))")
            print("version:\(String(describing: version))")
            print("uploadMethod:\(String(describing: uploadMethod))")
            print("urlUpload:\(String(describing: urlUpload))")
            print("databaseName:\(String(describing: databaseName))")
            print("packageName:\(String(describing: packageName))")
            //print("\(String(describing:UserName))")
            NotificationCenter.default.post(name: notificationName, object: nil)
            //result("iOS fk_EmpGlCode:\(String(describing: fk_EmpGlCode)) :: UserName:\(String(describing: UserName)) imei:\(String(describing: imei)) version:\(String(describing: version)) uploadMethod:\(String(describing: uploadMethod)) databaseName:\(String(describing: databaseName)) packageName:\(String(describing: packageName))" + UIDevice.current.systemVersion)
            let retval = FileSyncData(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei,uploadMethod:uploadMethod,urlUpload:urlUpload,databaseName:databaseName)
            
            result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)*/
            
        }else if(call.method == "UniqueNumber"){
            let retValue = getDeviceUniqueNo()
            result(retValue)
        }else if(call.method == "syncronizeDataFile"){
          // Sagar File Sync ################################################
          
          let UserName : String = dict["UserName"] ?? ""
          let fk_EmpGlCode : String = dict["fk_EmpGlCode"] ?? ""
          let ClientName : String = dict["ClientName"] ?? ""
          let imei : String = dict["imei"] ?? ""
          let version : String = dict["version"] ?? ""
          let uploadMethod : String = dict["uploadMethod"] ?? ""
          let logUploadMethod : String = dict["logUploadMethod"] ?? ""
          let urlUpload : String = dict["urlUpload"] ?? ""
          var databaseName : String = dict["databaseName"] ?? ""
          let packageName : String = dict["packageName"] ?? ""
          
          print("UserName:\(String(describing: UserName))")
          print("fk_EmpGlCode:\(String(describing: fk_EmpGlCode))")
          print("ClientName:\(String(describing: ClientName))")
          print("imei:\(String(describing: imei))")
          print("version:\(String(describing: version))")
          print("uploadMethod:\(String(describing: uploadMethod))")
          print("logUploadMethod:\(String(describing: logUploadMethod))")
          print("urlUpload:\(String(describing: urlUpload))")
          print("databaseName:\(String(describing: databaseName))")
          print("packageName:\(String(describing: packageName))")
          NotificationCenter.default.post(name: notificationName, object: nil)
          
          let retval = FileSyncData(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei, uploadMethod:uploadMethod, logUploadMethod:logUploadMethod, urlUpload:urlUpload, databaseName:databaseName)
          
          result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)
        }else if(call.method == "getTimeFromUTC"){
            let date : String = dict["date"] ?? ""
            let formatType : String = dict["format"] ?? ""
            
            let result1 = date.toServerDateUTC().toMyFormatDate(format: formatType)
            result(result1)
        }else if(call.method == "checkInternet"){
          let result1 = Reachability.isConnectedToNetwork()
          if(result1){
               print("true")
               result("true")
          }else{
               print("false")
               result("false")
          }
          //result(result1)
        }else if(call.method == "checkBarCode"){
          let code : String = dict["code"] ?? ""
          var stringValue : String = code
          //codeScanned = stringValue
          
          
          
          print("stringValue code: \(stringValue)")
          var isGoing = false
          
          if(stringValue.characters.count <= 14){
               isGoing = true
          }
          
          if(isGoing == false){
               let swiftyString = stringValue.replacingOccurrences(of: "\"", with: "")
               print("swiftyString:\(swiftyString)")
               let trimmedString = swiftyString.trimmingCharacters(in: .whitespaces)
               print("trimmedString:\(trimmedString)")
               
               //let group = trimmedString.components(separatedBy: "29")
               //print(group)
               
               var ites:Int = 0
               var finalStr:String = ""
               var groupSaprator:String = ""
               while(ites < trimmedString.characters.count){
                    let firstChar = Array(trimmedString)[ites]
                    print("char:\(firstChar)")
                    //let asc = trimmedString.index(trimmedString.startIndex, offsetBy: ites)
                    //print(asc)
                    let charAscii = firstChar.ascii
                    if(charAscii != 29){
                         finalStr = finalStr + "\(firstChar)"
                    }else{
                         finalStr = finalStr + "\(firstChar)"
                         groupSaprator = "\(firstChar)"
                    }
                    
                    ites = ites + 1
               }
               
               if(!finalStr.isEmpty){
                    if(!groupSaprator.isEmpty){
                         let group = finalStr.components(separatedBy: groupSaprator)
                         print(group)
                         print(group[0])
                         print(group[1])
                         
                         var str1:String = group[group.count - 1]
                         print(str1)
                         if(!str1.isEmpty){
                              //let str2 = str1.removeAtIndex(enhance(str1.startIndex, 1))
                              //let ffStr = str2.removeAtIndex(enhance(str2.startIndex, 1))
                              
                              if let index = str1.index(str1.startIndex, offsetBy: 0, limitedBy: str1.endIndex) {
                                   str1.remove(at: index)
                                   print(str1) // prints "Hello I must be going"
                              }
                              
                              if let index = str1.index(str1.startIndex, offsetBy: 0, limitedBy: str1.endIndex) {
                                   str1.remove(at: index)
                                   print(str1) // prints "Hello I must be going"
                              }
                              
                              stringValue = str1
                              print("stringValue : \(stringValue)")
                         }
                    }
               }
          }
          
          result(stringValue)
        }else{
            result("iOS syncronizeData not found" + UIDevice.current.systemVersion)
        }
    }
     
     
     
     //File Sync Start
     var SyncId: Int = 0
     var userName: String = "", fk_EmpGlCode: String = "", ClientName: String = "", version: String = "", imei: String = "", uploadMethod: String = "", logUploadMethod: String = "", urlUpload: String = ""
     
     func FileSyncData(userName:String, fk_EmpGlCode:String, ClientName:String, version:String, imei:String, uploadMethod:String, logUploadMethod:String, urlUpload:String, databaseName:String)->String{
          
          self.userName=userName;
          self.fk_EmpGlCode=fk_EmpGlCode;
          self.ClientName=ClientName;
          self.version=version;
          self.imei=imei;
          self.uploadMethod=uploadMethod;
          self.logUploadMethod=logUploadMethod;
          self.urlUpload=urlUpload;
          
          writeLog(key: "FB_SYNC_START", value: "")
          updateProgress(type: 1, message: "progress", min: 1, max: 7)
          
          var isGoahead:Bool = true
          var isGoaheadMessage:String = ""
          
          let date = Date()
          let calendar = Calendar.current
          
          let year = calendar.component(.year, from: date)
          let month = calendar.component(.month, from: date)
          let day = calendar.component(.day, from: date)
          
          let hour = calendar.component(.hour, from: date)
          let minute = calendar.component(.minute, from: date)
          let second = calendar.component(.second, from: date)
          
          let fileManager = FileManager.default
          
          let filePathSyncBackUp = documentsPath.appendingPathComponent("SyncBackup")
          let filePathSyncDownload = documentsPath.appendingPathComponent("SyncDownload")
          
          let dateString = String(format: "%02ld%02ld%ld_%02ld%02ld%02ld", day, month, year, hour, minute, second)
          
          //let fName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(version)"
          let fName = "\(dateString)_\(version)"
          let fileMainDir = filePathSyncBackUp?.appendingPathComponent("\(day)/\(fName)")
          let zipName = "\(fName).zip"
          let filePathSyncDownloadZip = filePathSyncDownload!.appendingPathComponent(fName)
          let fileMainDirZip = filePathSyncBackUp?.appendingPathComponent("\(day)/\(zipName)")
          
          let dirCDPD = fileMainDir?.appendingPathComponent("CCDPD")
          let dirCRPD = fileMainDir?.appendingPathComponent("CCRPD")
          let dirCCSD = fileMainDir?.appendingPathComponent("CCSD")
          let dirCCSDR = fileMainDir?.appendingPathComponent("CCSDR")
          let dirCSD = fileMainDir?.appendingPathComponent("CPM_Sticker_Details")
          
          if(!deleteDir(path: filePathSyncBackUp! as NSURL)){
               isGoahead = false;
               isGoaheadMessage = "error:101";
          }
          
          deleteDir(path: filePathSyncDownload! as NSURL)
          createDir(path: filePathSyncBackUp! as NSURL)
          createDir(path: filePathSyncDownload! as NSURL)
          createDir(path: fileMainDir! as NSURL)
          createDir(path: dirCDPD! as NSURL)
          createDir(path: dirCRPD! as NSURL)
          createDir(path: dirCCSD! as NSURL)
          createDir(path: dirCCSDR! as NSURL)
          createDir(path: dirCSD! as NSURL)
          
          let fileLoginDetails$_1 = "LoginDetails$_1.txt";
          let fileCPM_Customer_Dispatch$_1 = "CPM_Customer_Dispatch$_1.txt";
          let fileCPM_Customer_Dispatch_Product_Details$_1 = "CPM_Customer_Dispatch_Product_Details$_1.txt";
          let fileCPM_Customer_Receive$_1 = "CPM_Customer_Receive$_1.txt";
          let fileCPM_Customer_Receive_Product_Details$_1 = "CPM_Customer_Receive_Product_Details$_1.txt";
          
          updateProgress(type: 1, message: "progress", min: 7, max: 10)
          
          let jsonLoginDetails = getJsonFromTable(database: database, tableName: "LoginDetails")
          generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginDetails$_1, sBody: "\(jsonLoginDetails)")
          
          let jsonCPM_Customer_Dispatch = getJsonFromTable(database: database, tableName: "CPM_Customer_Dispatch")
          generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Dispatch$_1, sBody: "\(jsonCPM_Customer_Dispatch)")
          
          updateProgress(type: 1, message: "progress", min: 10, max: 12)
          let jsonCPM_Customer_Receive = getJsonFromTable(database: database, tableName: "CPM_Customer_Receive")
          generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Receive$_1, sBody: "\(jsonCPM_Customer_Receive)")
          
          updateProgress(type: 1, message: "progress", min: 12, max: 15)
          writeTransactionTablesToFile(tableName: "CPM_Customer_Dispatch_Product_Details", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCDPD?.path)!)
          
          updateProgress(type: 1, message: "progress", min: 15, max: 18)
          writeTransactionTablesToFile(tableName: "CPM_Customer_Receive_Product_Details", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCRPD?.path)!)
          
          updateProgress(type: 1, message: "progress", min: 18, max: 20)
          writeTransactionTablesToFile(tableName: "CPM_Customer_Sticker_Damage", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCCSD?.path)!)
          writeTransactionTablesToFile(tableName: "CPM_Customer_Sticker_Damage_Remove", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCCSDR?.path)!)
          
          updateProgress(type: 1, message: "progress", min: 20, max: 22)
          writeTransactionTablesToFile(tableName: "CPM_Sticker_Details", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCSD?.path)!)
          
          updateProgress(type: 1, message: "progress", min: 22, max: 25)
          
          writeLog(key: "CREATE_ZIP_START", value: "")
          // Create ZIP FIle
          let success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path, withContentsOfDirectory: fileMainDir!.path)
          if(success){
               writeLog(key: "CREATE_ZIP_END", value: "Success")
               isGoahead = true
          }else{
               writeLog(key: "CREATE_ZIP_END", value: "Error creating zip")
               isGoahead = false
               isGoaheadMessage = "Error creating zip"
          }
          
          var fileData: NSData? = nil
          var fileData1:String  = ""
          if(success){
               do {
                    writeLog(key: "ENCODE_ZIP_START", value: "")
                    var fileSizeValue: UInt64 = 0
                    do {
                         let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: fileMainDirZip!.path)
                         
                         if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                              fileSizeValue = UInt64(fileNumberSize)
                              writeLog(key: "UPLOAD_ZIP_SIZE", value: "\(fileSizeValue)")
                              let byteCountFormatter = ByteCountFormatter()
                              byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
                         }
                    } catch {
                         print(error.localizedDescription)
                    }
                    
                    try fileData = NSData(contentsOfFile: fileMainDirZip!.path, options: NSData.ReadingOptions.mappedIfSafe)
                    
                    fileData1 = fileData!.base64EncodedString(options: NSData.Base64EncodingOptions([]))
                    writeLog(key: "ENCODE_ZIP_END", value: "")
               }
               catch let error as NSError {
                    writeLog(key: "ENCODE_ZIP_ERROR", value: "\(error)")
                    print("Ooops! Something went wrong : \(error)")
                    isGoahead = false;
                    isGoaheadMessage = "error:104"
               }
          }
          
          updateProgress(type: 1, message: "progress", min: 26, max: 60)
          
          // Call API
          if(isGoahead){
               writeLog(key: "UPLOAD_ZIP_START", value: "")
               let web = urlUpload+uploadMethod
               print(web)
               print("FileName \(zipName)")
               print("DeviceId \(imei)")
               print("PersonId \(fk_EmpGlCode)")
               print("Version \(version)")
               print("APIToken \(userName)")
               
               let parameters = [
                    "FileArray": "\(fileData1)",
                    "FileName": zipName,
                    "DeviceId": "\(imei)",
                    "PersonId": "\(fk_EmpGlCode)",
                    "Version": "\(version)",
                    "SubModuleName": ClientName,
                    "APIToken": "\(userName)",
               ]
               
               /*let parameters = [
                "FileArray": "\(fileData1)",
                "FileName": zipName,
                "DeviceId": "000000000000000",
                "PersonId": "3",
                "Version": "18.0.11",
                "SubModuleName": "BASF_HK_Device",
                "APIToken": "3B6D5CE1-0F9F-468E-A42F-2F4F7EFEF8A8",
                ]*/
               
               writeLog(key: "UPLOAD_ZIP_API_START", value: "")
               self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)
                    
                    .responseString { response in
                         print("Success: \(response.result)")
                         print(response.timeline)
                         
                         switch response.result {
                         case .success(let jsonData):
                              self.writeLog(key: "UPLOAD_ZIP_END", value: "SUCCESS")
                              self.updateProgress(type: 1, message: "progress", min: 61, max: 65)
                              print("Success with JSON: \(jsonData)")
                              
                              // delete directory
                              self.deleteDir(path: fileMainDir! as NSURL)
                              
                              print(jsonData)
                              
                              do{
                                   let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData
                                   
                                   let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]
                                   
                                   let anyObj = JSON(json)
                                   
                                   var isValid:String = ""
                                   var Message:String = ""
                                   var Response:String = ""
                                   
                                   if anyObj["Status"].exists(){
                                        print("inside Status")
                                        let list: Array<JSON> = anyObj["Status"].arrayValue
                                        
                                        isValid =  anyObj["Status"].stringValue
                                        Message =  anyObj["Message"].stringValue
                                        Response =  anyObj["Response"].stringValue
                                   }else{
                                        isValid =  anyObj["Status"].stringValue
                                        Message =  anyObj["Message"].stringValue
                                        self.writeLog(key: "SYNC_ERROR", value: Message)
                                   }
                                   
                                   if anyObj["SyncId"].exists(){
                                        self.SyncId = anyObj["SyncId"].intValue
                                   }
                                   
                                   if(isValid == "1"){
                                        self.writeLog(key: "UPLOAD_ZIP_API_SUCCESS", value: "")
                                        if (self.isConnectedToNetwork() == true ){
                                             let destination: DownloadRequest.DownloadFileDestination = { _, _ in
                                                  let fileURL = filePathSyncDownload!.appendingPathComponent("\(zipName)")
                                                  return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
                                             }
                                             
                                             Alamofire.download(Response, to: destination).response { response in
                                                  print(response)
                                                  
                                                  if response.error == nil, let zipPath = response.destinationURL?.path {
                                                       print(zipPath)
                                                       
                                                       var fileSizeValue: UInt64 = 0
                                                       
                                                       do {
                                                            let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: zipPath)
                                                            
                                                            if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                                                                 fileSizeValue = UInt64(fileNumberSize)
                                                            }
                                                       } catch {
                                                            print(error.localizedDescription)
                                                       }
                                                       
                                                       self.updateProgress(type: 1, message: "progress", min: 66, max: 98)
                                                       
                                                       self.createDir(path: filePathSyncDownloadZip as NSURL)
                                                       if(self.unzipFile(zipPath: (filePathSyncDownload?.appendingPathComponent("\(zipName)").path)!, destinationPath: filePathSyncDownloadZip.path)){
                                                            print("Unzipped")
                                                            //CPM_Sticker_Details/CPM_Sticker_Details$_1.txt
                                                            
                                                            let enumerator = fileManager.enumerator(atPath: filePathSyncDownloadZip.path)
                                                            let filePaths = enumerator?.allObjects as! [String]
                                                            let txtFilePaths = filePaths.filter{$0.contains(".txt")}
                                                            
                                                            if self.database.open()
                                                            {
                                                                 let deleteQuery = "DELETE FROM CPM_Customer_Dispatch_Product_Details WHERE chrSync = 'N'"
                                                                 self.database.executeQuery(deleteQuery, withArgumentsIn: [])
                                                                 
                                                                 let deleteQuery2 = "DELETE FROM CPM_Customer_Receive_Product_Details WHERE chrSync = 'N'"
                                                                 self.database.executeQuery(deleteQuery2, withArgumentsIn: [])
                                                                 
                                                                 let deleteQuery3 = "DELETE FROM CPM_Customer_Sticker_Damage WHERE chrSync = 'N'"
                                                                 self.database.executeQuery(deleteQuery3, withArgumentsIn: [])
                                                                 
                                                                 let deleteQuery4 = "DELETE FROM CPM_Customer_Sticker_Damage_Remove WHERE chrSync = 'N'"
                                                                 self.database.executeQuery(deleteQuery4, withArgumentsIn: [])
                                                            }
                                                            
                                                            for txtFilePath in txtFilePaths{
                                                                 print("FilePath \(txtFilePath)")
                                                                 let fileURL = filePathSyncDownloadZip.appendingPathComponent(txtFilePath)
                                                                 let tableName = fileURL.path.fileName().split(separator: "$")
                                                                 print("tableName \(tableName)")
                                                                 
                                                                 do {
                                                                      let stringJSON = try String(contentsOf: fileURL, encoding: .utf8)
                                                                      
                                                                      let json = JSON.init(parseJSON:stringJSON)
                                                                      isGoahead = self.insertRecordDynamic(tableName: String(tableName[0]), jsonArray: json)
                                                                      if(!isGoahead){
                                                                           isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                                           self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                                           self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                                           break;
                                                                      }
                                                                 }
                                                                 catch {
                                                                      print("Error Reading \(txtFilePath)")
                                                                      isGoahead = false
                                                                      isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                                      self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                                      self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                                 }
                                                            }
                                                            
                                                            if(isGoahead){
                                                                 self.writeLog(key: "SYNC_DONE", value: "")
                                                                 self.updateProgress(type: 3, message: "Sync Successfully Done", min: 100, max: 100)
                                                            }else{
                                                                 self.writeLog(key: "SYNC_FAIL", value: isGoaheadMessage)
                                                                 self.updateProgress(type: 2, message: isGoaheadMessage, min: 100, max: 100)
                                                            }
                                                       }else{
                                                            isGoahead = false
                                                            isGoaheadMessage = "Error in extract zip file"
                                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                       }
                                                  }else{
                                                       isGoahead = false
                                                       isGoaheadMessage = "Error in download zip file"
                                                       self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                       self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                  }
                                             }
                                        }else{
                                             isGoaheadMessage = "NO_INTERNET"
                                             self.writeLog(key: "UPLOAD_ZIP_END", value: isGoaheadMessage)
                                             self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                        }
                                   }else if(isValid == "2"){
                                        isGoaheadMessage = "Session expired. Please try again";
                                        self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                   }else{
                                        isGoaheadMessage = Message;
                                        self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                   }
                              }catch{
                                   isGoaheadMessage = "server error:@, please try again \(jsonData)";
                                   self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                                   self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                              }
                         case .failure(let error):
                              print("Request failed with error: \(error)")
                              let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
                              self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                              self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                         }
               }
          }else{
               self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
               self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
          }
          //xx
          return isGoaheadMessage
     }
     
     func insertRecordDynamic(tableName:String, jsonArray:JSON)->Bool{
          var success = true
          
          do{
               let isTranTable = (tableName == DBHelper.TABLE_CPM_CUSTOMER_DISPATCH
                    || tableName == DBHelper.TABLE_CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS
                    || tableName == DBHelper.TABLE_CPM_CUSTOMER_RECEIVE
                    || tableName == DBHelper.TABLE_CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS
                    || tableName == DBHelper.TABLE_CPM_CUSTOMER_STICKER_DAMAGE
                    || tableName == DBHelper.TABLE_CPM_CUSTOMER_STICKER_DAMAGE_REMOVE
                    || tableName == DBHelper.TABLE_PERSON_MST
                    || tableName == DBHelper.TABLE_PRODUCT_SKU_MST
                    || tableName == DBHelper.TABLE_CUSTOMER_PARTNER_MST
                    || tableName == DBHelper.TABLE_CUSTOMER_TYPE_COUNTRY_MST
                    || tableName == DBHelper.TABLE_POLITICAL_GEOGRAPHY_LEVEL_COUNTRY_MST
                    || tableName == DBHelper.TABLE_POLITICAL_GEOGRAPHY_DETAILS
                    || tableName == DBHelper.TABLE_CPM_STRICKER_Details)
               
               if !isTranTable && self.database.open()
               {
                    let deleteQuery = "DELETE FROM \(tableName)"
                    self.database.executeQuery(deleteQuery, withArgumentsIn: [])
               }else{
                    if (tableName != DBHelper.TABLE_CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS
                         && tableName != DBHelper.TABLE_CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS
                         && tableName != DBHelper.TABLE_CPM_CUSTOMER_STICKER_DAMAGE
                         && tableName != DBHelper.TABLE_CPM_CUSTOMER_STICKER_DAMAGE_REMOVE) {
                         
                         let deleteQuery = "DELETE FROM \(tableName) WHERE chrSync = 'N'"
                         self.database.executeQuery(deleteQuery, withArgumentsIn: [])
                    }
               }
               
               if(jsonArray.count>0){
                    var sbQuery = "INSERT INTO \(tableName) ("
                    
                    let keys = jsonArray[0].dictionaryValue.keys
                    
                    var sbQuery2 = ""
                    for (position, name) in keys.enumerated() {
                         if(name=="chrTran"){
                              continue
                         }
                         if(position != 0){
                              sbQuery2.append(",")
                         }
                         sbQuery2.append(name)
                    }
                    
                    sbQuery.append(sbQuery2)
                    sbQuery.append(" ) VALUES ")
                    
                    let arraySize = jsonArray.count
                    let BATCHSIZE = 500
                    let intBatch = Int(CGFloat(ceil(Double(Double(arraySize) * 1.00 / Double(BATCHSIZE)))))-1
                    let intRemainder = Int(Double(arraySize).truncatingRemainder(dividingBy: Double(BATCHSIZE)))
                    var intMaxRecords = Int(BATCHSIZE)
                    
                    for b in 0...intBatch {
                         var finalInsert=""
                         finalInsert.append(sbQuery)
                         if (b == intBatch) {
                              intMaxRecords = intRemainder == 0 ? BATCHSIZE : intRemainder;
                         }
                         
                         var valuesBuiler=""
                         var deleteValues = [String]()
                         var deleteQ=""
                         let innerLoopSize = Int((b * Int(BATCHSIZE)) + intMaxRecords)-1
                         let tmp1 = Int((b * BATCHSIZE))
                         
                         for m in tmp1...innerLoopSize {
                              let jsonObject = jsonArray[m]
                              if(jsonObject.dictionaryValue.keys.contains("chrTran")){
                                   let chrTran = jsonObject.dictionaryValue["chrTran"]?.string
                                   
                                   if (jsonObject.dictionaryValue.keys.contains("varSync_Code")) {
                                        deleteQ.append(deleteValues.count <= 0 ? "?" : ",?")
                                        deleteValues.append((jsonObject.dictionaryValue["varSync_Code"]?.string)!)
                                   }
                                   if (chrTran != nil && chrTran!.caseInsensitiveCompare("d") == .orderedSame) {
                                        continue
                                   }
                              }
                              
                              if (!valuesBuiler.isEmpty){
                                   valuesBuiler.append(",")
                              }
                              
                              valuesBuiler.append("(")
                              
                              for (pos, key) in jsonObject.dictionaryValue.keys.enumerated() {
                                   let hasNext = (pos != jsonObject.dictionaryValue.keys.count-1)
                                   if (key=="chrTran") {
                                        if (!hasNext && valuesBuiler.contains(",")) {
                                             valuesBuiler.remove(at: valuesBuiler.lastIndex(of: ",")!)
                                        }
                                        continue
                                   }
                                   let tmp = jsonObject.dictionaryValue[key]?.string
                                   if (tmp != nil && !(tmp?.isEmpty)! && tmp != "null") {
                                        valuesBuiler.append("'")
                                        valuesBuiler.append(tmp!.replace(target: "'", withString: "''"))
                                        valuesBuiler.append("'")
                                   } else {
                                        valuesBuiler.append("NULL")
                                   }
                                   valuesBuiler.append(hasNext ? "," : "")
                              }
                              valuesBuiler.append(")")
                         }
                         finalInsert.append(valuesBuiler)
                         //print("FINAL_INSERT_QUERY ## \(finalInsert)")
                         
                         if(isTranTable){
                              let deleteQuery = "DELETE FROM \(tableName) WHERE varSync_Code IN (\(deleteQ))"
                              let deleteCount = self.database.executeUpdate(deleteQuery, withArgumentsIn: deleteValues)
                              print("##DELETED##\(deleteCount)")
                         }
                         
                         let insertCount = self.database.executeUpdate(finalInsert, withArgumentsIn: [])
                         print("##INSERTED##\(insertCount)")
                    }
               }
          } catch let error as NSError {
               NSLog("insertRecordDynamic \(error.debugDescription)")
               success=false
          }
          
          return success
     }
     
     func unzipFile(zipPath: String, destinationPath:String) -> Bool{
          var fileUnZip = false
          let s:Bool =  SSZipArchive.unzipFile(atPath: zipPath, toDestination: destinationPath)
          if(s){
               fileUnZip = true
               print("unzip zip file")
          }else{
               fileUnZip = false
               print("not unzip zip file")
          }
          return fileUnZip
     }
     
     func writeLog(key: String, value: String){
          let todaysDate = getCurrentDateTimeFormated()
          let logData = "\(key) $$$ \(value) $$$ Date Time:- \(todaysDate)"
          //print(logData)
          hashMap[key] = logData
     }
     
     func updateProgress(type:Int, message:String, min: Int, max: Int){
          returnItems = ["type": "\(type)","Details": message,"progress": "\(randomNumber(MIN: min, MAX: max))"]
          NotificationCenter.default.post(name: notificationName, object: nil)
          
          if(type==2 || type==3){
               var status=""
               if(type==2){
                    status="N"
               }else{
                    status="Y"
               }
               
               self.callUpload(urlUpload: urlUpload, logUploadMethod: logUploadMethod, fk_EmpGlCode: fk_EmpGlCode, SyncId: self.SyncId, DeviceSyncStatus: status, DeviceSyncJson: status, ClientName: ClientName, imei: imei, version: version, userName: userName)
          }
     }
     
     func deleteTable(database:FMDatabase, tableName:String){
          if database.open()
          {
               let deleteQuery = "DELETE FROM \(tableName) WHERE chrSync = 'N'"
               database.executeQuery(deleteQuery, withArgumentsIn: [])
          }
     }
     
     func getJsonFromTable(database:FMDatabase,tableName:String)->JSON{
          //var varIntRowCount:String = ""
          if database.open()
          {
               let selectQuery = "SELECT * FROM \(tableName) WHERE chrSync = 'N'"
               //print(selectQuery)
               
               if let rs = database.executeQuery(selectQuery, withArgumentsIn: [])
               {
                    var data = [JSON]()
                    
                    while(rs.next()){
                         let dir = rs.resultDictionary
                         //print(dir)
                         let json = JSON(dir)
                         data.append(json)
                    }
                    return JSON(data)
               }
          }
          
          return JSON("[]")
     }
     
     func writeTransactionTablesToFile(tableName: String, NumberOfRecordPerArray: Int, intRowNumber: Int, filePath: String) {
          
          var isExit:Bool = false
          var fileCount:Int = 0
          var tmpRowNumber = intRowNumber
          
          var jsonArray = [JSON]()
          
          repeat {
               let selectQuery = "SELECT * FROM \(tableName) WHERE chrSync = 'N' AND intGlCode > \(tmpRowNumber) LIMIT 2000"
               
               let selectQueryCount = "SELECT COUNT(*) as Count FROM \(tableName) WHERE chrSync = 'N' AND intGlCode > \(tmpRowNumber) LIMIT 2000"
               
               //print(selectQuery)
               
               var count = 0
               if let rs = database.executeQuery(selectQueryCount, withArgumentsIn: []) {
                    while rs.next() {
                         count = Int(rs.int(forColumn: "Count"))
                         print("Total Records:", count)
                    }
               }
               if(count>0){
                    if let rs = database.executeQuery(selectQuery, withArgumentsIn: [])
                    {
                         var data = [JSON]()
                         
                         var limitCount=0
                         while(rs.next()){
                              let dir = rs.resultDictionary
                              //print(dir)
                              let json = JSON(dir)
                              //print(json)
                              data.append(json)
                              limitCount+=1
                              
                              isExit = limitCount==count
                              
                              if(data.count >= 1000 || isExit){
                                   fileCount+=1;
                                   generateTextFile(root: filePath, sFileName: "\(tableName)$_\(fileCount).txt", sBody: "\(data)")
                                   //tmpRowNumber = data[data.count-1].arrayValue.last!["intGlCode"].intValue
                                   tmpRowNumber = dir!["intGlCode"] as! Int
                                   data.removeAll()
                              }
                         }
                    }
               }else{
                    isExit = true
               }
               
          } while !isExit;
     }
     
     func generateTextFile(root: String, sFileName: String, sBody: String){
          let filePath = root.appending("/" + sFileName)
          
          do {
               try sBody.write(toFile: filePath, atomically: false, encoding: String.Encoding.utf8)
          }
          catch let error as NSError {
               print("An error took place: \(error)")
          }
     }
     
     func callUpload(urlUpload: String, logUploadMethod: String, fk_EmpGlCode: String, SyncId: Int, DeviceSyncStatus: String, DeviceSyncJson: String, ClientName: String, imei: String, version: String, userName: String){
          let DeviceSyncJson="\(self.hashMap)"
          print("DeviceSyncJson ### \(DeviceSyncJson)")
          
          self.uploadLogToServerAfterSync(urlUpload: urlUpload, logUploadMethod: logUploadMethod, PersonId: fk_EmpGlCode, SyncId: self.SyncId, DeviceSyncStatus: DeviceSyncStatus, DeviceSyncJson: DeviceSyncJson, SubModuleName: ClientName, DeviceId: imei, Version: version, APIToken: userName)
     }
     
     func uploadLogToServerAfterSync(urlUpload: String, logUploadMethod: String, PersonId: String, SyncId: Int, DeviceSyncStatus: String, DeviceSyncJson: String, SubModuleName: String, DeviceId: String, Version: String, APIToken: String){
          print("uploadLogToServerAfterSync START \(DeviceSyncStatus)")
          let parameters = [
               "PersonId": "\(PersonId)",
               "SyncId": "\(SyncId)",
               "DeviceSyncStatus": "\(DeviceSyncStatus)",
               "DeviceSyncJson": "\(DeviceSyncJson)",
               "SubModuleName": "\(SubModuleName)",
               "DeviceId": "\(DeviceId)",
               "Version": "\(Version)",
               "APIToken": "\(APIToken)"
          ]
          
          let web = urlUpload + logUploadMethod
          self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)
               
               .responseString { response in
                    print("Success: \(response.result)")
          }
          
     }
     
     func getCurrentDateTimeFormated() -> String{
          let date : Date = Date()
          let dateFormatter = DateFormatter()
          dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
          return dateFormatter.string(from: date)
     }
     
     //File Sync END
    
    @objc func onBatteryStateDidChange(_ notification: Notification?) {
        print("onBatteryStateDidChange")
        sendBatteryStateEvent()
    }
    
    func sendBatteryStateEvent() {
        if eventSink == nil {
            print("eventSink nil")
            return
        }
        
        eventSink?(returnItems)
        
    }
    
    public func onListen(withArguments arguments: Any?, eventSink: @escaping FlutterEventSink) -> FlutterError? {
        self.eventSink = eventSink
        //UIDevice.current.isBatteryMonitoringEnabled = true
        //sendBatteryStateEvent()
        NotificationCenter.default.addObserver(self, selector: #selector(onBatteryStateDidChange(_:)), name: notificationName, object: nil)
        return nil
    }
    
    public func onCancel(withArguments arguments: Any?) -> FlutterError? {
        NotificationCenter.default.removeObserver(self)
        eventSink = nil
        return nil
    }
    
    /*func handle(_ call: FlutterMethodCall?, result: FlutterResult) {
     if ("getBatteryLevel" == call?.method) {
     let batteryLevel: Int = getBatteryLevel()
     if batteryLevel == -1 {
     result(FlutterError(code: "UNAVAILABLE", message: "Battery info unavailable", details: nil))
     } else {
     result(batteryLevel)
     }
     } else {
     result(FlutterMethodNotImplemented)
     }
     }*/
    
    /*func getBatteryLevel() -> Int {
     let device = UIDevice.current
     device.isBatteryMonitoringEnabled = true
     if device.batteryState == .unknown {
     return -1
     } else {
     return Int(device.batteryLevel * 100)
     }
     }*/
    
    func SyncData(userName:String,fk_EmpGlCode:String,ClientName:String,version:String,imei:String,uploadMethod:String,urlUpload:String,databaseName:String, dbPassword:String, isDbEncripted:String)->String{
        
        returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 1,MAX: 5))"]
        NotificationCenter.default.post(name: notificationName, object: nil)
     
     
        
     
        
        var isGoahead:Bool = true
        var isGoaheadMessage:String = ""
        
        let date = Date()
        let calendar = Calendar.current
        
        let year = calendar.component(.year, from: date)
        let month = calendar.component(.month, from: date)
        let day = calendar.component(.day, from: date)
        
        let hour = calendar.component(.hour, from: date)
        let minute = calendar.component(.minute, from: date)
        let second = calendar.component(.second, from: date)
        
        let dirName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_\(databaseName)"
        
        let fileName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_\(databaseName)"
        let zipName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_BASF-HK-Database"
        self.zipNameFinal = zipName
        // App database path
        let filePathFrom = documentsPath.appendingPathComponent(databaseName)?.path
        let filePathTo = documentsPath.appendingPathComponent("SyncDatabase")?.path
        let filePathTo1 = documentsPath.appendingPathComponent("SyncDatabase/\(databaseName)")?.path
        let filePathTo2 = documentsPath.appendingPathComponent("SyncDatabase/\(fileName)")?.path
        let fileManager = FileManager.default
        
        //createDirSyncDb(documentsPath)
        
        if fileManager.fileExists(atPath: filePathTo!) {
            do {
                try fileManager.removeItem(atPath: filePathTo!)
            } catch let error as NSError {
                NSLog("delete directory \(error.debugDescription)")
                isGoahead = false;
                isGoaheadMessage = "error:101";
                
            }
            createDirSyncDb(documentsPath: documentsPath)
        } else {
            createDirSyncDb(documentsPath: documentsPath)
        }
        
        if(isGoahead){
            if fileManager.fileExists(atPath: filePathTo1!) {
                print("filePathTo1 exist")
            }
            if fileManager.fileExists(atPath: filePathTo2!) {
                print("filePathTo2 exist")
            }
            //databaseName = "BASF-HK-Database"
            let filePathToZip = documentsPath.appendingPathComponent("SyncDatabase/\(zipName).zip")?.path
            
            let newDirectory = documentsPath.appendingPathComponent("SyncDatabase/\(dirName)")?.path
            
            let newDirectory1 = documentsPath.appendingPathComponent("SyncDatabase/\(dirName)/\(fileName)")?.path
            
            do {
                try fileManager.createDirectory(atPath: newDirectory!, withIntermediateDirectories: false, attributes: nil)
            } catch let error as NSError {
                print(error.localizedDescription);
                print("error create newDirectory")
                print("Ooops! Something went wrong createDirectory: \(error)")
                isGoahead = false;
                isGoaheadMessage = "error:103";
            }
            
            //copy from SyncDatabase to document
            if fileManager.fileExists(atPath: filePathFrom!) {
                do {
                    try fileManager.copyItem(atPath: filePathFrom!, toPath: newDirectory1!)
                } catch let error as NSError {
                    NSLog("Unable to copy file \(error.debugDescription)")
                    print("Ooops! Something went wrong copyItem: \(error)")
                    isGoahead = false;
                    isGoaheadMessage = "error:103";
                }
            }
            
            returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 6,MAX: 10))"]
            NotificationCenter.default.post(name: notificationName, object: nil)
            
            if(isGoahead){
                
                let success = SSZipArchive.createZipFile(atPath: filePathToZip!, withContentsOfDirectory: newDirectory!)
                if(success){
                    isGoahead = true
                }else{
                    isGoahead = false
                    isGoaheadMessage = "Error creating zip"
                }
                
                var fileData: NSData? = nil
                var fileData1:String  = ""
                do {
                    /******* HOME *******/
                    
                    var fileSizeValue: UInt64 = 0
                    do {
                        
                        let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: filePathToZip!)
                        
                        if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                            fileSizeValue = UInt64(fileNumberSize)
                            
                            let byteCountFormatter = ByteCountFormatter()
                            byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
                            print(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))
                            
                        }
                        
                    } catch {
                        print(error.localizedDescription)
                    }
                    
                    try fileData = NSData(contentsOfFile: filePathToZip!, options: NSData.ReadingOptions.mappedIfSafe)
                    
                    fileData1 = fileData!.base64EncodedString(options: NSData.Base64EncodingOptions([]))
                    /*********************/
                    //print(fileData)
                    //print(fileData1)
                }
                catch let error as NSError {
                    print("Ooops! Something went wrong renamefile: \(error)")
                    isGoahead = false;
                    isGoaheadMessage = "error:104";
                }
                
                returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 11,MAX: 25))"]
                NotificationCenter.default.post(name: notificationName, object: nil)
                
                if(isGoahead){
                    // let web = urlUpload+"/"+uploadMethod
                    let web = urlUpload+uploadMethod
                    print(web)
                    
                    /*let parameters = [
                     "fk_EmpGLCode": "\(fk_EmpGlCode)",
                     "varClientName": "\(ClientName)",
                     "strAppType": "IOS","strVersion": "\(version)","varIMEINumber": "\(imei)","UserName": "\(userName)","Filename": "\(zipName).zip","FileArray": "\(fileData1)","varAppType":"IOS",
                     ]*/
                    
                    /* parameterPost.put("FileArray", encodeDb);
                     parameterPost.put("FileName", strFilename);
                     parameterPost.put("DeviceId", Imei);
                     parameterPost.put("PersonId", fk_EmpGlCode);
                     parameterPost.put("Version", strVersion);
                     parameterPost.put("SubModuleName", ClientName);
                     parameterPost.put("APIToken", UserName);*/
                    
                    
                    let parameters = [
                        "FileArray": "\(fileData1)",
                        "FileName": "\(zipName).zip",
                        "DeviceId": "\(imei)","PersonId": "\(fk_EmpGlCode)","Version": "\(version)","SubModuleName": "\(ClientName)","APIToken": "\(userName)",
                    ]
                    
                    print(parameters)
                    
                    self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)
                        
                        .responseString { response in
                            print("Success: \(response.result)")
                            print(response.timeline)
                            
                            switch response.result {
                            case .success(let jsonData):
                                print("Success with JSON: \(jsonData)")
                                
                                /**** comment temp to check file ******/
                                // delete sync directory
                                if fileManager.fileExists(atPath: filePathTo!) {
                                    print("FILE AVAILABLE")
                                    //var error: NSError?
                                    do {
                                        try fileManager.removeItem(atPath: filePathTo!)
                                    } catch let error as NSError {
                                        NSLog("delete directory \(error.debugDescription)")
                                        //FIRCrashMessage("delete directory:error:5")
                                    }
                                    
                                    self.createDirSyncDb(documentsPath: self.documentsPath)
                                    //createDirectory(documentsPath: documentsPath)
                                }
                                
                                
                                print(jsonData)
                                do{
                                    self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 26,MAX: 40))"]
                                    NotificationCenter.default.post(name: self.notificationName, object: nil)
                                    
                                    let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData
                                    
                                    let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]
                                    
                                    let anyObj = JSON(json)
                                    
                                    
                                    print("**********************")
                                    print("*******SYNC RESPONSE********")
                                    print("**********************")
                                    print(anyObj)
                                    print("**********************")
                                    print("**********************")
                                    print("**********************")
                                    
                                    var isValid:String = ""
                                    var Message:String = ""
                                    
                                    if anyObj["Status"].exists(){
                                        
                                        print("inside Status")
                                        
                                        let list: Array<JSON> = anyObj["Status"].arrayValue
                                        
                                        /*isValid = list[0]["isValid"].stringValue
                                         Message = list[0]["Message"].stringValue*/
                                        
                                        isValid =  anyObj["Status"].stringValue
                                        Message =  anyObj["Response"].stringValue
                                        
                                    }else{
                                        isValid =  anyObj["Status"].stringValue
                                        Message =  anyObj["Response"].stringValue
                                    }
                                    
                                    if(isValid.lowercased() == "1"){
                                        self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 41,MAX: 45))"]
                                        NotificationCenter.default.post(name: self.notificationName, object: nil)
                                        if (self.isConnectedToNetwork() == true ){
                                            self.downloadFile(urlStr: Message,zipFileName: "\(zipName).zip",databaseName: databaseName)
                                        }else{
                                            isGoaheadMessage = "NO_INTERNET"
                                            self.returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                                            NotificationCenter.default.post(name: self.notificationName, object: nil)
                                        }
                                    }else{
                                        
                                        
                                        isGoaheadMessage = "server error:!, please try again \(anyObj)";
                                        self.returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                                        NotificationCenter.default.post(name: self.notificationName, object: nil)
                                        
                                    }
                                }catch{
                                    isGoaheadMessage = "server error:@, please try again \(jsonData)";
                                    self.returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                                    NotificationCenter.default.post(name: self.notificationName, object: nil)
                                }
                                
                                
                                
                            case .failure(let error):
                                print("Request failed with error: \(error)")
                                
                                let message = "# Oops something went wrong, please try again \(error)"
                                isGoaheadMessage = message;
                                self.returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                                NotificationCenter.default.post(name: self.notificationName, object: nil)
                            }
                    }
                    
                    return isGoaheadMessage
                    
                }else{
                    returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                    NotificationCenter.default.post(name: notificationName, object: nil)
                    return isGoaheadMessage
                }
            }else{
                returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                NotificationCenter.default.post(name: notificationName, object: nil)
                return isGoaheadMessage
            }
        }else{
            returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
            NotificationCenter.default.post(name: notificationName, object: nil)
            return isGoaheadMessage
        }
    }
    
   /* func FileSyncData(userName:String,fk_EmpGlCode:String,ClientName:String,version:String,imei:String,uploadMethod:String,urlUpload:String,databaseName:String)->String{
        
        returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 1,MAX: 7))"]
        NotificationCenter.default.post(name: notificationName, object: nil)
        
        var isGoahead:Bool = true
        var isGoaheadMessage:String = ""
        
        let date = Date()
        let calendar = Calendar.current
        
        let year = calendar.component(.year, from: date)
        let month = calendar.component(.month, from: date)
        let day = calendar.component(.day, from: date)
        
        let hour = calendar.component(.hour, from: date)
        let minute = calendar.component(.minute, from: date)
        let second = calendar.component(.second, from: date)
        
        let dirName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_\(databaseName)"
        
        let fileName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_\(databaseName)"
        let zipName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_BASF-HK-Database"
        self.zipNameFinal = zipName
 
        let fileManager = FileManager.default
        
        let filePathSyncBackUp = documentsPath.appendingPathComponent("SyncBackup")
        let fName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)"
        let fileMainDir = filePathSyncBackUp?.appendingPathComponent("\(day)/\(fName)")
        
        let dirCDPD = fileMainDir?.appendingPathComponent("CCDPD")
        let dirCRPD = fileMainDir?.appendingPathComponent("CCRPD")
        let dirCCSD = fileMainDir?.appendingPathComponent("CCSD")
        let dirCCSDR = fileMainDir?.appendingPathComponent("CCSDR")
        let dirCSD = fileMainDir?.appendingPathComponent("CPM_Sticker_Details")
        
        /*if(!deleteDir(path: filePathSyncBackUp! as NSURL)){
            isGoahead = false;
            isGoaheadMessage = "error:101";
        }*/
        
        createDir(path: filePathSyncBackUp! as NSURL)
        createDir(path: fileMainDir! as NSURL)
        createDir(path: dirCDPD! as NSURL)
        createDir(path: dirCRPD! as NSURL)
        createDir(path: dirCCSD! as NSURL)
        createDir(path: dirCCSDR! as NSURL)
        createDir(path: dirCSD! as NSURL)
        
        let fileCPM_Customer_Dispatch$_1 = "CPM_Customer_Dispatch$_1.txt";
        let fileLoginDetails$_1 = "LoginDetails$_1.txt";
        
        let fileCPM_Customer_Dispatch_Product_Details$_1 = "CPM_Customer_Dispatch_Product_Details$_1.txt";
        let fileCPM_Customer_Receive$_1 = "CPM_Customer_Receive$_1.txt";
        let fileCPM_Customer_Receive_Product_Details$_1 = "CPM_Customer_Receive_Product_Details$_1.txt";
        
        returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 7,MAX: 10))"]
        
        let res = DBHelper.getJsonFromTable(database: database, tableName: "CPM_Customer_Dispatch")
        return isGoaheadMessage
    }*/
    
    func downloadFile(urlStr:String, zipFileName:String,databaseName:String){
        
        //print("downloadFile path :: \(urlStr)")
        //print("downloadFile name :: \(zipFileName)")
        
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "HH:mm:ss"
        
        //let diff = self.getDiffTime(time2: Date())
        //self.data_createJson.setValue("\(diff)", forKey: "6_UPLOAD_END")
        
        //let diff1 = self.getDiffTime(time2: Date())
        //self.data_createJson.setValue("\(diff1)", forKey: "8_DOWNLOAD_START")
        
        let destination: DownloadRequest.DownloadFileDestination = { _, _ in
            let documentsURL = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask)[0]
            let fileURL = documentsURL.appendingPathComponent("SyncDatabase/Download/\(zipFileName)")
            
            return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
        }
        
        Alamofire.download(urlStr, to: destination).response { response in
            print(response)
            
            if response.error == nil, let imagePath = response.destinationURL?.path {
                //let image = UIImage(contentsOfFile: imagePath)
                
                print(imagePath)
                //end - diff
                //let dateFormatter = DateFormatter()
                //dateFormatter.dateFormat = "HH:mm:ss"
                //let diff = self.getDiffTime(time2: Date())
                //self.data_createJson.setValue("\(diff)", forKey: "9_DOWNLOAD_END")
                
                self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 46,MAX: 60))"]
                NotificationCenter.default.post(name: self.notificationName, object: nil)
                
                var fileSizeValue: UInt64 = 0
                
                do {
                    let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: imagePath)
                    
                    if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                        fileSizeValue = UInt64(fileNumberSize)
                        
                        //let byteCountFormatter = ByteCountFormatter()
                        //byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
                        //print(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))
                        
                        //self.data_createJson.setValue("\(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))", forKey: "9_DOWNLOAD_FILE_SIZE")
                    }
                } catch {
                    print(error.localizedDescription)
                }
                self.unzipDirectory(unZipFile: zipFileName,databaseName: databaseName)
            }else{
            }
        }
    }
    
    func unzipDirectory(unZipFile:String,databaseName:String){
        // unzip & copy
        
        DispatchQueue.main.async {
            
            self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 61,MAX: 74))"]
            NotificationCenter.default.post(name: self.notificationName, object: nil)
            
            let fileManager = FileManager.default
            
            let documentsPath = NSURL(fileURLWithPath: NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true)[0])
            let filePathToZip = documentsPath.appendingPathComponent("SyncDatabase/Download/\(unZipFile)")?.path
            let filePathfromZip = documentsPath.appendingPathComponent("SyncDatabase")?.path
            let oldDBName = documentsPath.appendingPathComponent("SyncDatabase/\(self.zipNameFinal.lowercased()).db")?.path
            let newDBName = documentsPath.appendingPathComponent("SyncDatabase/\(databaseName)")?.path
            
            let documentDBName = documentsPath.appendingPathComponent("\(databaseName)")?.path
            
            print("********************")
            print(filePathToZip)
            print(filePathfromZip)
            print(oldDBName)
            print(newDBName)
            print(documentDBName)
            print("********************")
            
            
            //print("1 --> \(filePathToZip)")
            // print("2 --> \(filePathfromZip)")
            var fileUnZip:Bool = false
            
            let s:Bool =  SSZipArchive.unzipFile(atPath: filePathToZip!, toDestination: filePathfromZip!)
            if(s){
                fileUnZip = true
                print("unzip zip file")
            }else{
                fileUnZip = false
                print("not unzip zip file")
            }
            
            self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 75,MAX: 84))"]
            NotificationCenter.default.post(name: self.notificationName, object: nil)
            
            if(fileUnZip){
                // rename file
                //print("3 --> \(oldDBName)")
                //print("4 --> \(newDBName)")
                
                print("oldDBName:\(oldDBName)")
                print("newDBName:\(newDBName)")
                print("documentDBName:\(documentDBName)")
                
                if fileManager.fileExists(atPath: oldDBName!) {
                    
                    do {
                        try fileManager.moveItem(atPath: oldDBName!, toPath: newDBName!)
                    }
                    catch let error as NSError {
                        print("Ooops! Something went wrong renamefile: \(error)")
                        //self.data_createJson.setValue("error", forKey: "RESTORE_DB_END_FAIL_10")
                        self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 1","progress": "0"]
                        NotificationCenter.default.post(name: self.notificationName, object: nil)
                    }
                }
                
                if fileManager.fileExists(atPath: documentDBName!) {
                    do {
                        try fileManager.removeItem(atPath: documentDBName!)
                    } catch let error as NSError {
                        print("error delete file \(error.debugDescription)")
                        //self.data_createJson.setValue("error", forKey: "RESTORE_DB_END_FAIL_10")
                        self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 2","progress": "0"]
                        NotificationCenter.default.post(name: self.notificationName, object: nil)
                    }
                }
                
                //print("5 --> \(newDBName)")
                //print("6 --> \(documentDBName)")
                
                //copy from SyncDatabase to document
                
                if fileManager.fileExists(atPath: newDBName!) {
                    do {
                        //restor starts
                        let dateFormatter = DateFormatter()
                        dateFormatter.dateFormat = "HH:mm:ss"
                        
                        //let diff = self.getDiffTime(time2: Date())
                        
                        
                        //self.data_createJson.setValue("\(diff)", forKey: "10_RESTORE_DB_START")
                        print(newDBName)
                        if fileManager.fileExists(atPath: newDBName!) {
                            
                            print(newDBName)
                        }
                        
                        print(documentDBName)
                        
                        if fileManager.fileExists(atPath: documentDBName!) {
                            
                            print(documentDBName)
                        }
                        
                        
                        try fileManager.copyItem(atPath: newDBName!, toPath: documentDBName!)
                    } catch let error as NSError {
                        NSLog("Unable to copy file \(error.debugDescription)")
                        //self.data_createJson.setValue("error)", forKey: "10_RESTORE_DB_END_FAIL")
                        self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 3","progress": "0"]
                        NotificationCenter.default.post(name: self.notificationName, object: nil)
                        
                    }
                }else{
                    print("newDBName:\(newDBName)")
                    
                    self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 4","progress": "0"]
                    NotificationCenter.default.post(name: self.notificationName, object: nil)
                }
                
               //sleep(200)
                
                let filePathTo = documentsPath.appendingPathComponent("SyncDatabase")?.path
                // delete sync directory
                if fileManager.fileExists(atPath: filePathTo!) {
                    print("FILE AVAILABLE")
                    //var error: NSError?
                    do {
                        try fileManager.removeItem(atPath: filePathTo!)
                    } catch let error as NSError {
                        NSLog("delete directory \(error.debugDescription)")
                        //self.data_createJson.setValue("error", forKey: "10_RESTORE_DB_END_FAIL")
                        self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 5","progress": "0"]
                        NotificationCenter.default.post(name: self.notificationName, object: nil)
                        
                    }
                    
                    //self.createDirectory(documentsPath)
                }
                
               //sleep(10)
                
                //DispatchQueue.main.async {
                self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 85,MAX: 97))"]
                NotificationCenter.default.post(name: self.notificationName, object: nil)
                // }
                
               // sleep(10)
                
                // DispatchQueue.main.async {
                self.returnItems = ["type": "3","Details": "Sync Successfully Done","progress": "100"]
                NotificationCenter.default.post(name: self.notificationName, object: nil)
                // }
                
                
                //dispatch_async(dispatch_get_main_queue()) {
                
                //self.currentDateDB = ECP_Constant.checkFlagLableMaser("SYNCDATE");
                
                //self.isAllowCheck = ECP_Constant.checkFlagLableMaserBool("CheckReviewOnVisit");
                
                
                
                /*let date = Date()
                 let calendar = Calendar.current
                 
                 let year = calendar.component(.year, from: date)
                 let month = calendar.component(.month, from: date)
                 let day = calendar.component(.day, from: date)
                 
                 let hour = calendar.component(.hour, from: date)
                 let minute = calendar.component(.minute, from: date)
                 let second = calendar.component(.second, from: date)
                 
                 self.isallowflag = self.checkDate(isFirst: false)
                 
                 let defaults = UserDefaults.standard
                 defaults.set(NSDate(), forKey: ECP_Constant.VAR_LAST_SYNC_TIME_DATE);*/
                
                //ECP_Constant.IS_VALID_LOGIN)
                
                /* var i:Int = 0
                 while (i<10000) {
                 i = i + 1
                 }*/
                
                //sleep(500)
                
                //end
                // let dateFormatter = DateFormatter()
                // dateFormatter.dateFormat = "HH:mm:ss"
                
                //let diff = self.getDiffTime(time2: Date())
                
                //self.data_createJson.setValue("\(diff)", forKey: "11_RESTORE_DB_END")
                
                //let diff2 = self.getEndTimeDiff(time2: timeStart)
                //self.data_createJson.setValue("\(diff2)", forKey: "12_END")
                
                //self.MessageLastSync(msg: "Sync Successfully Done")
                //let varLastSyncTime:String = "\(day)/\(month)/\(year) \(hour):\(DBAdapter.addZero(value: minute)):\(second)"
                //let defaults = NSUserDefaults.standardUserDefaults()
                //defaults.setValue(varLastSyncTime, forKey: ECP_Constant.VAR_LAST_SYNC_TIME)
                //self.setSyncTime()
                //self.getModuleList()
                //}
            }else{
                //dispatch_async(dispatch_get_main_queue()) {
                //self.showAlertMessageSync(messageM: "Ooops! Something went wrong")
                //}
                
                self.returnItems = ["type": "2","Details": "Ooops! Something went wrong","progress": "0"]
                NotificationCenter.default.post(name: self.notificationName, object: nil)
            }
        }
    }
    
    func randomNumber(MIN: Int, MAX: Int)-> Int{
        return Int(arc4random_uniform(UInt32(MAX-MIN)) + UInt32(MIN));
    }
    
    func createDirSyncDb(documentsPath:NSURL){
        let logsPath = documentsPath.appendingPathComponent("SyncDatabase")
        do {
            try FileManager.default.createDirectory(atPath: logsPath!.path, withIntermediateDirectories: true, attributes: nil)
        } catch let error as NSError {
            NSLog("Unable to create directory \(error.debugDescription)")
        }
    }
    
    func createDir(path:NSURL){
        do {
            try FileManager.default.createDirectory(atPath: path.path!, withIntermediateDirectories: true, attributes: nil)
        } catch let error as NSError {
            NSLog("Unable to create directory \(error.debugDescription)")
        }
    }
    
    func deleteDir(path:NSURL) -> Bool{
        if FileManager.default.fileExists(atPath: path.path!){
            do {
                try FileManager.default.removeItem(atPath: path.path!)
            } catch let error as NSError {
                NSLog("delete directory \(path) \(error.debugDescription)")
                return false
            }
        }
        return true
    }
    
    func isConnectedToNetwork() -> Bool {
        
        var zeroAddress = sockaddr_in(sin_len: 0, sin_family: 0, sin_port: 0, sin_addr: in_addr(s_addr: 0), sin_zero: (0, 0, 0, 0, 0, 0, 0, 0))
        zeroAddress.sin_len = UInt8(MemoryLayout.size(ofValue: zeroAddress))
        zeroAddress.sin_family = sa_family_t(AF_INET)
        
        let defaultRouteReachability = withUnsafePointer(to: &zeroAddress) {
            $0.withMemoryRebound(to: sockaddr.self, capacity: 1) {zeroSockAddress in
                SCNetworkReachabilityCreateWithAddress(nil, zeroSockAddress)
            }
        }
        
        var flags: SCNetworkReachabilityFlags = SCNetworkReachabilityFlags(rawValue: 0)
        if SCNetworkReachabilityGetFlags(defaultRouteReachability!, &flags) == false {
            return false
        }
        
        /* Only Working for WIFI
         let isReachable = flags == .reachable
         let needsConnection = flags == .connectionRequired
         
         return isReachable && !needsConnection
         */
        
        // Working for Cellular and WIFI
        let isReachable = (flags.rawValue & UInt32(kSCNetworkFlagsReachable)) != 0
        let needsConnection = (flags.rawValue & UInt32(kSCNetworkFlagsConnectionRequired)) != 0
        let ret = (isReachable && !needsConnection)
        
        return ret
        
    }
    
    func getDeviceUniqueNo()->String{
        let udifstr = UIDevice.current.identifierForVendor!.uuidString
        let mili:Int64 = getCurrentMillis()
        let rand:Int64 = getRandomNumber()
        let iint:Int = "\(mili)".characters.count
        let iii = udifstr + "\(iint)" + "\(rand)";
        print(iii)
        return iii
    }
    
    func getCurrentMillis()->Int64 {
        return Int64(Date().timeIntervalSince1970 * 1000)
    }
    
    func getRandomNumber()->Int64 {
        let number = floor(Double(arc4random_uniform(1000) * 6000)) + 1000
        return Int64(number)
    }
}

/*extension Range
 {
 var randomInt: Int
 {
 get
 {
 var offset = 0
 
 if (startIndex as Int) < 0   // allow negative ranges
 {
 offset = abs(startIndex as Int)
 }
 
 let mini = UInt32(startIndex as Int + offset)
 let maxi = UInt32(endIndex   as Int + offset)
 
 return Int(mini + arc4random_uniform(maxi - mini)) - offset
 }
 }
 }*/

extension String {
    func aesEncrypt(key: String, iv: String) throws -> String{
        //let data = self.dataUsingEncoding(NSUTF8StringEncoding)
        let data1 = self.data(using: .utf8)
        let enc = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).encrypt(data1!.bytes)
        let encData = NSData(bytes: enc, length: Int(enc.count))
        let base64String: String = encData.base64EncodedString(options: NSData.Base64EncodingOptions(rawValue: 0));
        let result = String(base64String)
        return result
    }
    
    func aesDecrypt(key: String, iv: String) throws -> String {
        // let data1 = NSData(base64Encoded: self.data(using: .utf8)!, options: NSData.Base64DecodingOptions(rawValue: 0))
        let data1 = Data(base64Encoded: self)!
        let dec = try AES(key: key, iv: iv, blockMode:.CBC).decrypt(Array(data1))
        let decData = NSData(bytes: dec, length: Int(dec.count))
        let result = NSString(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
        return String(result!)
    }
}

extension String {
    /*func aesEncrypt(key: String, iv: String) throws -> String{
     //let data = self.dataUsingEncoding(NSUTF8StringEncoding)
     let data1 = self.data(using: .utf8)
     let enc = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).encrypt(data1!.bytes)
     let encData = NSData(bytes: enc, length: Int(enc.count))
     let base64String: String = encData.base64EncodedString(options: NSData.Base64EncodingOptions(rawValue: 0));
     let result = String(base64String)
     return result
     }
     
     func aesDecrypt(key: String, iv: String) throws -> String {
     //let data1 = NSData(base64Encoded: self, options: NSData.Base64DecodingOptions(rawValue: 0))
     let data1 = Data(base64Encoded: self)!
     let dec = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).decrypt(Array(data1))
     let decData = NSData(bytes: dec, length: Int(dec.count))
     let result = NSString(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
     //let result = String(bytes: Data(decData).bytes, encoding: .utf8)
     print(decData)
     //let result =  String(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
     return String(result!)
     }*/
    
    /* let key = "B4V2A1C@S#S$F"
     let iv = "0000000000000000"
     let s = "Vcs@1234"
     let enc = try! s.aesEncrypt1(key: key, iv: iv)
     print(enc)
     
     do{
     let dec = try enc.aesDecrypt1(key: key, iv: iv)
     print("dec:\(dec)")
     print("\(s == dec)")
     
     }catch let error {
     print("error:\(error)")
     }*/
    
    func aesEncrypt1(key: String, iv: String) throws -> String {
        
        
        let pwdBytes = [UInt8](key.utf8)
        var keyBytes: [UInt8] = Array(arrayLiteral: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
        var len = pwdBytes.count
        if(len > keyBytes.count){
            len = keyBytes.count
            //keyBytes = NSArray(array:b, copyItems: true) as! [UInt8]
        }
        
        var i:Int = 0
        while(i < len){
            keyBytes[i] = pwdBytes[i]
            i = i + 1
        }
        
        let key1 = keyBytes
        let iv1 = keyBytes
        
        let encrypted = try AES(key: key1, iv: iv1, blockMode:.CBC, padding: .pkcs5).encrypt([UInt8](self.data(using: .utf8)!))
        return Data(encrypted).base64EncodedString()
    }
    
    func aesDecrypt1(key: String, iv: String) throws -> String {
        
        let pwdBytes = [UInt8](key.utf8)
        var keyBytes: [UInt8] = Array(arrayLiteral: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
        var len = pwdBytes.count
        if(len > keyBytes.count){
            len = keyBytes.count
            //keyBytes = NSArray(array:b, copyItems: true) as! [UInt8]
        }
        
        var i:Int = 0
        while(i < len){
            keyBytes[i] = pwdBytes[i]
            i = i + 1
        }
        
        let key1 = keyBytes
        let iv1 = keyBytes
        
        guard let data = Data(base64Encoded: self) else { return "" }
        let decrypted = try AES(key: key1, iv: iv1, blockMode:.CBC, padding: .pkcs5).decrypt([UInt8](data))
        return String(bytes: Data(decrypted).bytes, encoding: .utf8) ?? "Could not decrypt"
    }
    
}

extension String {
    
    func toDate() -> Date {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd" //Your date format
        dateFormatter.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        let date = dateFormatter.date(from: self)
        return date!
    }
    
    func toServerDateUTC() -> Date {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss" //Your date format
        dateFormatter.timeZone = TimeZone(abbreviation: "UTC") //Current time zone
        let date = dateFormatter.date(from: self)
        return date!
    }
    
    func toEntryDDate() -> Date {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss" //Your date format
        dateFormatter.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        let date = dateFormatter.date(from: self)
        return date!
    }
    
    func toEntryDDateUTC1() -> Date {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss" //Your date format
        dateFormatter.timeZone = TimeZone(abbreviation: "UTC") //Current time zone
        let date = dateFormatter.date(from: self)
        return date!
    }
    
    
    func toConvertTimeAMPM() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss" //Your date format
        dateFormatter.locale = Locale(identifier: "en_US_POSIX")
        
        //        dateFormatter.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        let date = dateFormatter.date(from: self)
        
        let dateFormatter1 = DateFormatter()
        dateFormatter1.dateFormat = "hh:mm:ss a" //Your date format
        dateFormatter1.locale = Locale(identifier: "en_US_POSIX")
        
        //        dateFormatter1.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        let date2 = dateFormatter1.string(from: date!)
        
        return date2
    }
    
    //    func toShowTimeAMPM() -> String {
    //        let dateFormatter1 = DateFormatter()
    //        dateFormatter1.dateFormat = "hh:mm:ss a" //Your date format
    //        dateFormatter1.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
    //        let date2 = dateFormatter1.string(from: dateFormatter1.date(from: self)!)
    //
    //        return date2
    //    }
    
    
    func replace(target: String, withString: String) -> String
    {
        return self.replacingOccurrences(of: target, with: withString, options: NSString.CompareOptions.literal, range: nil)
    }
}

extension Date {
    
    func monthsFromDate(from date: Date) -> Int {
        return Calendar.current.dateComponents([.month], from: date, to: self).month ?? 0
    }
    
    func toDayNameString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "EEEE"
        let str = dateFormatter.string(from: self)
        let index = str.index(str.startIndex, offsetBy: 3)
        return str.substring(to: index)
        //return mySubstring
    }
    
    func toDayString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "EEEE"
        return dateFormatter.string(from: self)
    }
    
    func toPlanStringGMT() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd"
        dateFormatter.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        
        return dateFormatter.string(from: self)
    }
    
    func toPlanString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd"
        return dateFormatter.string(from: self)
    }
    
    func toPlanShowMonthString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "dd-MMM-yyyy"
        return dateFormatter.string(from: self)
    }
    
    func toShowTimeAMPM() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "hh:mm a"
        return dateFormatter.string(from: self)
    }
    
    func toTime24Hours() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "HH:mm"
        return dateFormatter.string(from: self)
    }
    
    func toPlanShowString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "dd-MM-yyyy"
        return dateFormatter.string(from: self)
    }
    
    func toEntryDate() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
        return dateFormatter.string(from: self)
    }
    
    func toMyFormatDate(format:String) -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = format
        return dateFormatter.string(from: self)
    }
    
    func toEntryTime() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "HH:mm:ss"
        dateFormatter.locale = Locale(identifier: "en_US_POSIX")
        
        return dateFormatter.string(from: self)
    }
    
    func toMonth() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.month, from: self)
        return month
    }
    
    func toDay() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.day, from: self)
        return month
    }
    
    func toHour() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.hour, from: self)
        return month
    }
    
    func toMinute() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.minute, from: self)
        return month
    }
    
    //let dateFormatter = DateFormatter()
    //dateFormatter.dateFormat = "MMM-YYYY"
    
    func toMonthYearString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "MMM-YYYY"
        return dateFormatter.string(from: self)
    }
    
    func toFullMonthYearString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "MMMM-YYYY"
        return dateFormatter.string(from: self)
    }
    
    func toFullYearString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "YYYY"
        return dateFormatter.string(from: self)
    }
    
    func toMonthString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "MMMM"
        return dateFormatter.string(from: self)
    }
    
    func toYear() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.year, from: self)
        return month
    }
    
    func addRemoveYear(month1:Int)->Date{
        return Calendar.current.date(byAdding: .year, value: month1, to: self)!
    }
    
    func addRemoveMonth(month1:Int)->Date{
        return Calendar.current.date(byAdding: .month, value: month1, to: self)!
    }
    
    func addRemoveDay(month1:Int)->Date{
        return Calendar.current.date(byAdding: .day, value: month1, to: self)!
    }
    
    
    /*func startOfMonth() -> Date {
     return Calendar.current.date(from: Calendar.current.dateComponents([.year, .month], from: Calendar.current.startOfDay(for: self)))!
     }
     
     func endOfMonth() -> Date {
     return Calendar.current.date(byAdding: DateComponents(month: 1, day: -1), to: self.startOfMonth())!
     }*/
    
    func startOfMonth() -> Date {
        
        let calendar = Calendar.current
        let currentDateComponents = calendar.dateComponents([.year, .month], from: self)
        let startOfMonth = calendar.date(from: currentDateComponents)
        
        return startOfMonth!
    }
    
    func dateByAddingMonths(_ monthsToAdd: Int) -> Date? {
        
        let calendar = Calendar.current
        var months = DateComponents()
        months.month = monthsToAdd
        
        return calendar.date(byAdding: months, to: self)
    }
    
    func endOfMonth() -> Date {
        
        let plusOneMonthDate = dateByAddingMonths(1)
        
        let calendar = Calendar.current
        let plusOneMonthDateComponents = calendar.dateComponents([.year, .month], from: plusOneMonthDate!)
        let endOfMonth = calendar.date(from: plusOneMonthDateComponents)?.addingTimeInterval(-1)
        
        return endOfMonth!
        
    }
    
    func dayOfTheWeek() -> String? {
        let weekdays = [
            "Sunday",
            "Monday",
            "Tuesday",
            "Wednesday",
            "Thursday",
            "Friday",
            "Saturday"
        ]
        
        let calendar = Calendar.current
        let components = calendar.dateComponents([.weekday], from: self)
        return weekdays[components.weekday! - 1]
    }
    
}

extension String {
     func fileName() -> String {
          return URL(fileURLWithPath: self).deletingPathExtension().lastPathComponent
     }
     
     func fileExtension() -> String {
          return URL(fileURLWithPath: self).pathExtension
     }
}

public class Reachability {
     
     class func isConnectedToNetwork() -> Bool {
          
          var zeroAddress = sockaddr_in(sin_len: 0, sin_family: 0, sin_port: 0, sin_addr: in_addr(s_addr: 0), sin_zero: (0, 0, 0, 0, 0, 0, 0, 0))
          zeroAddress.sin_len = UInt8(MemoryLayout.size(ofValue: zeroAddress))
          zeroAddress.sin_family = sa_family_t(AF_INET)
          
          let defaultRouteReachability = withUnsafePointer(to: &zeroAddress) {
               $0.withMemoryRebound(to: sockaddr.self, capacity: 1) {zeroSockAddress in
                    SCNetworkReachabilityCreateWithAddress(nil, zeroSockAddress)
               }
          }
          
          var flags: SCNetworkReachabilityFlags = SCNetworkReachabilityFlags(rawValue: 0)
          if SCNetworkReachabilityGetFlags(defaultRouteReachability!, &flags) == false {
               return false
          }
          
          /* Only Working for WIFI
           let isReachable = flags == .reachable
           let needsConnection = flags == .connectionRequired
           
           return isReachable && !needsConnection
           */
          
          // Working for Cellular and WIFI
          let isReachable = (flags.rawValue & UInt32(kSCNetworkFlagsReachable)) != 0
          let needsConnection = (flags.rawValue & UInt32(kSCNetworkFlagsConnectionRequired)) != 0
          let ret = (isReachable && !needsConnection)
          
          return ret
          
     }
}
